diff -Nur kwin.orig/kwin/popupinfo.cpp kwin-4.1.82/kwin/popupinfo.cpp
--- kwin.orig/kwin/popupinfo.cpp	2008-02-21 10:28:05.000000000 +0100
+++ kwin-4.1.82/kwin/popupinfo.cpp	2008-12-13 04:11:46.647648942 +0100
@@ -92,25 +92,16 @@
 void PopupInfo::paintEvent( QPaintEvent* )
     {
     QPainter p( this );
-    QStyleOptionFrame *so = new QStyleOptionFrame;
-    so->rect = QRect( 0, 0, width(), height() );
-    so->palette = palette();
-    so->palette.setCurrentColorGroup( QPalette::Active );
-    so->state = QStyle::State_None;
-    style()->drawPrimitive( QStyle::PE_Frame, so, &p );
-    paintContents();
-    }
-
+    QStyleOptionFrame so;
+    so.rect = QRect( 0, 0, width(), height() );
+    so.palette = palette();
+    so.palette.setCurrentColorGroup( QPalette::Active );
+    so.state = QStyle::State_None;
+    style()->drawPrimitive( QStyle::PE_Frame, &so, &p );
 
-/*!
-  Paints the contents of the tab popup info box.
-  Used in paintEvent() and whenever the contents changes.
- */
-void PopupInfo::paintContents()
+    if (m_shown)
     {
-    QPainter p( this );
     QRect r( 6, 6, width()-12, height()-12 );
-
     p.fillRect( r, palette().brush( QPalette::Active, QPalette::Background ) );
 
     /*
@@ -124,6 +115,9 @@
     p.drawText( r, Qt::AlignCenter, m_infoString );
     }
 
+    }
+
+
 void PopupInfo::hide()
     {
     m_delayedHideTimer.stop();
@@ -149,16 +143,16 @@
         {
         m_infoString = infoString;
         reset();
-        if (m_shown)
-            {
-            paintContents();
-            }
-        else
+        if (!m_shown)
             {
             show();
             raise();
             m_shown = true;
             }
+	else
+	   {
+	   repaint();
+	   }
         m_delayedHideTimer.start(m_delayTime);
         }
     }
diff -Nur kwin.orig/kwin/popupinfo.h kwin-4.1.82/kwin/popupinfo.h
--- kwin.orig/kwin/popupinfo.h	2008-11-12 17:37:21.000000000 +0100
+++ kwin-4.1.82/kwin/popupinfo.h	2008-12-13 02:27:30.119649095 +0100
@@ -47,7 +47,6 @@
 
     protected:
         void paintEvent( QPaintEvent* );
-        void paintContents();
 
     private:
         QTimer m_delayedHideTimer;
